"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createLeafComponent = void 0;
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
function createLeafComponent(child) {
    var update$ = new rxjs_1.Subject();
    var destroy$ = new rxjs_1.Subject();
    var render$ = new rxjs_1.ReplaySubject(1);
    update$.pipe(operators_1.takeUntil(destroy$))
        .subscribe(render$);
    return {
        type: 'leaf',
        data: child,
        render$: render$.asObservable(),
        update$: update$,
        destroy$: destroy$
    };
}
exports.createLeafComponent = createLeafComponent;
