"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createComponent = void 0;
var rxjs_1 = require("rxjs");
var Static_1 = require("./Static");
var Leaf_1 = require("./Leaf");
var Observable_1 = require("./Observable");
var Fn_1 = require("./Fn");
var Array_1 = require("./Array");
var isThenable_1 = require("../../helpers/isThenable");
var isFunction_1 = require("../../helpers/isFunction");
var isArray_1 = require("../../helpers/isArray");
exports.createComponent = function (child) {
    if (child == null || typeof child == 'number' || typeof child == 'string') {
        return Leaf_1.createLeafComponent(child);
    }
    else if (rxjs_1.isObservable(child)) {
        return Observable_1.createObservableComponent();
    }
    else if (isThenable_1.isThenable(child)) {
        return Observable_1.createObservableComponent();
    }
    else if (isArray_1.isArray(child)) {
        return Array_1.createArrayComponent();
    }
    else if (typeof child.type == 'string') {
        return Static_1.createStaticComponent(child);
    }
    else if (isFunction_1.isFunction(child.type)) {
        return Fn_1.createFnComponent(child);
    }
    throw 'Unknown type of child';
};
