import { ReplaySubject, Subject } from 'rxjs';
import { takeUntil } from 'rxjs/operators';
export function createLeafComponent(child) {
    const update$ = new Subject();
    const destroy$ = new Subject();
    const render$ = new ReplaySubject(1);
    update$.pipe(takeUntil(destroy$))
        .subscribe(render$);
    return {
        type: 'leaf',
        data: child,
        render$: render$.asObservable(),
        update$,
        destroy$
    };
}
