import { Subject } from 'rxjs';
import { switchMap, take, takeUntil } from 'rxjs/operators';
import { DynamicEntry } from '../DynamicEntry';
export function createObservableComponent() {
    const update$ = new Subject();
    const destroy$ = new Subject();
    const dynamicChild = DynamicEntry();
    destroy$.pipe(take(1))
        .subscribe(dynamicChild.destroy$);
    update$
        .pipe(switchMap(a => a), takeUntil(destroy$))
        .subscribe(result => {
        dynamicChild.update$.next(result);
    });
    return {
        type: 'observable',
        update$,
        destroy$,
        result$: dynamicChild.result$
    };
}
