import { ReplaySubject, Subject } from 'rxjs';
import { takeUntil } from 'rxjs/operators';
export function createLeafComponent(child) {
    var update$ = new Subject();
    var destroy$ = new Subject();
    var render$ = new ReplaySubject(1);
    update$.pipe(takeUntil(destroy$))
        .subscribe(render$);
    return {
        type: 'leaf',
        data: child,
        render$: render$.asObservable(),
        update$: update$,
        destroy$: destroy$
    };
}
