import { Subject } from 'rxjs';
import { switchMap, take, takeUntil } from 'rxjs/operators';
import { DynamicEntry } from '../DynamicEntry';
export function createObservableComponent() {
    var update$ = new Subject();
    var destroy$ = new Subject();
    var dynamicChild = DynamicEntry();
    destroy$.pipe(take(1))
        .subscribe(dynamicChild.destroy$);
    update$
        .pipe(switchMap(function (a) { return a; }), takeUntil(destroy$))
        .subscribe(function (result) {
        dynamicChild.update$.next(result);
    });
    return {
        type: 'observable',
        update$: update$,
        destroy$: destroy$,
        result$: dynamicChild.result$
    };
}
