import { isObservable } from 'rxjs';
import { createStaticComponent } from './Static';
import { createLeafComponent } from './Leaf';
import { createObservableComponent } from './Observable';
import { createFnComponent } from './Fn';
import { createArrayComponent } from './Array';
import { isThenable } from '../../helpers/isThenable';
import { isFunction } from '../../helpers/isFunction';
import { isArray } from '../../helpers/isArray';
export var createComponent = function (child) {
    if (child == null || typeof child == 'number' || typeof child == 'string') {
        return createLeafComponent(child);
    }
    else if (isObservable(child)) {
        return createObservableComponent();
    }
    else if (isThenable(child)) {
        return createObservableComponent();
    }
    else if (isArray(child)) {
        return createArrayComponent();
    }
    else if (typeof child.type == 'string') {
        return createStaticComponent(child);
    }
    else if (isFunction(child.type)) {
        return createFnComponent(child);
    }
    throw 'Unknown type of child';
};
