import { Observable, Subject } from 'rxjs';
import { IElement } from '../Element';
import { IStaticComponent } from './Static';
import { ILeafComponent } from './Leaf';
import { IObservableComponent } from './Observable';
import { IFnComponent } from './Fn';
import { IArrayComponent } from './Array';
export declare type IChild = null | number | string | IElement<any> | Array<IElement<any>> | Observable<any>;
export interface IBasicComponent {
    update$: Subject<IChild>;
    destroy$: Subject<void>;
}
export declare type IComponent = ILeafComponent | IStaticComponent | IObservableComponent | IFnComponent | IArrayComponent;
export declare const createComponent: (child: IChild) => IComponent;
//# sourceMappingURL=index.d.ts.map